/*******************************************************************************
 * DataStoreClient generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class DataStoreClient extends UIRoot
    native(UserInterface)
    config(Engine)
    hidecategories(Object,UIRoot);

struct native transient PlayerDataStoreGroup
{
    var init const transient LocalPlayer PlayerOwner;
    var init const transient array<UIDataStore> DataStores;

    structdefaultproperties
    {
        PlayerOwner=none
        DataStores=none
    }
};

var config array<config string> GlobalDataStoreClasses;
var const array<UIDataStore> GlobalDataStores;
var config array<config string> PlayerDataStoreClassNames;
var private const array< class<UIDataStore> > PlayerDataStoreClasses;
var const array<PlayerDataStoreGroup> PlayerDataStores;

// Export UDataStoreClient::execFindDataStore(FFrame&, void* const)
native final function UIDataStore FindDataStore(name DataStoreTag, optional LocalPlayer PlayerOwner);

// Export UDataStoreClient::execCreateDataStore(FFrame&, void* const)
native final function UIDataStore CreateDataStore(class<UIDataStore> DataStoreClass);

// Export UDataStoreClient::execRegisterDataStore(FFrame&, void* const)
native final function bool RegisterDataStore(UIDataStore DataStore, optional LocalPlayer PlayerOwner);

// Export UDataStoreClient::execUnregisterDataStore(FFrame&, void* const)
native final function bool UnregisterDataStore(UIDataStore DataStore);

// Export UDataStoreClient::execFindPlayerDataStoreIndex(FFrame&, void* const)
native final function int FindPlayerDataStoreIndex(LocalPlayer PlayerOwner);

final function GetPlayerDataStoreClasses(out array< class<UIDataStore> > out_DataStoreClasses)
{
    out_DataStoreClasses = PlayerDataStoreClasses;
    //return;    
}

final function class<UIDataStore> FindDataStoreClass(class<UIDataStore> RequiredMetaClass)
{
    local int I;
    local class<UIDataStore> Result;

    I = 0;
    J0x0B:
    // End:0xA8 [Loop If]
    if(I < GlobalDataStores.Length)
    {
        // End:0x9A
        if(GlobalDataStores[I].IsA(RequiredMetaClass.Name))
        {
            Result = GlobalDataStores[I].Class;
            // [Explicit Break]
            goto J0xA8;
        }
        ++ I;
        J0xA8:
        // [Loop Continue]
        goto J0x0B;
    }
    // End:0x12A
    if(Result == none)
    {
        I = 0;
        J0xC2:
        // End:0x12A [Loop If]
        if(I < PlayerDataStoreClasses.Length)
        {
            // End:0x11C
            if(ClassIsChildOf(PlayerDataStoreClasses[I], RequiredMetaClass))
            {
                Result = PlayerDataStoreClasses[I];
                // [Explicit Break]
                goto J0x12A;
            }
            ++ I;
            J0x12A:
            // [Loop Continue]
            goto J0xC2;
        }
    }
    return Result;
    //return ReturnValue;    
}

final event NotifyGameSessionEnded()
{
    local int I, DataStoreIndex;
    local array<UIDataStore> DataStoreArray;

    DataStoreArray = GlobalDataStores;
    DataStoreIndex = 0;
    J0x1E:
    // End:0x8D [Loop If]
    if(DataStoreIndex < DataStoreArray.Length)
    {
        // End:0x7F
        if(DataStoreArray[DataStoreIndex].NotifyGameSessionEnded())
        {
            UnregisterDataStore(DataStoreArray[DataStoreIndex]);
        }
        ++ DataStoreIndex;
        // [Loop Continue]
        goto J0x1E;
    }
    I = PlayerDataStores.Length - 1;
    J0xA4:
    // End:0x168 [Loop If]
    if(I >= 0)
    {
        DataStoreArray = PlayerDataStores[I].DataStores;
        DataStoreIndex = 0;
        J0xEE:
        // End:0x15A [Loop If]
        if(DataStoreIndex < DataStoreArray.Length)
        {
            DataStoreArray[DataStoreIndex].NotifyGameSessionEnded();
            UnregisterDataStore(DataStoreArray[DataStoreIndex]);
            ++ DataStoreIndex;
            // [Loop Continue]
            goto J0xEE;
        }
        -- I;
        // [Loop Continue]
        goto J0xA4;
    }
    //return;    
}

final function DebugDumpDataStoreInfo(bool bVerbose)
{
    //return;    
}

defaultproperties
{
    GlobalDataStoreClasses(0)="Engine.UIDataStore_GameResource"
    GlobalDataStoreClasses(1)="Engine.UIDataStore_Fonts"
    GlobalDataStoreClasses(2)="Engine.UIDataStore_Registry"
    GlobalDataStoreClasses(3)="Engine.UIDataStore_InputAlias"
    GlobalDataStoreClasses(4)="FoxGame.FoxDataStore_MenuItems"
    GlobalDataStoreClasses(5)="FoxGame.FoxDataStore_GameSearchAll"
    GlobalDataStoreClasses(6)="FoxGame.FoxDataStore_GameSettings"
    GlobalDataStoreClasses(7)="FoxGame.FoxDataStore_Unlockables"
    GlobalDataStoreClasses(8)="FoxGame.FoxDataStore_StoreData"
    GlobalDataStoreClasses(9)="FoxGame.FoxDataStore_OnlineStats"
    GlobalDataStoreClasses(10)="FoxGame.FoxDataStore_Playlists"
    GlobalDataStoreClasses(11)="FoxGame.FoxDataStore_Tutorials"
    GlobalDataStoreClasses(12)="FoxGame.FoxDataStore_AIPresets"
    GlobalDataStoreClasses(13)="FoxGame.FoxDataStore_GenericPickup"
    PlayerDataStoreClassNames(0)="FoxGame.FoxDataStore_OnlinePlayerData"
}